1826a20d6cf502c229962818910c7369f79f2101
[util-vserver.git] / scripts / vsomething
1 #! /bin/bash
2 # $Id: vsomething,v 1.3 2005/04/24 20:30:55 ensc Exp $
3
4 # Copyright (C) 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
5 #  
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
9 #  
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #  
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
18
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21     echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
22     exit 1
23 }
24 . "$UTIL_VSERVER_VARS"
25 . "$_LIB_FUNCTIONS"
26
27
28 function showHelp()
29 {
30     echo \
31 $"Usage: $0 [--quiet|-q] [--debug] <cmd> [--] <vserver-name>* [--all] -- <params>+
32
33 Execute <cmd> <vserver> <params>* foreach vserver.
34
35 Report bugs to <$PACKAGE_BUGREPORT>."
36     exit 0
37 }
38
39 function showVersion()
40 {
41     echo \
42 $"vsomething $PACKAGE_VERSION -- execute something for a set of vservers
43 This program is part of $PACKAGE_STRING
44
45 Copyright (C) 2005 Enrico Scholz
46 This program is free software; you may redistribute it under the terms of
47 the GNU General Public License.  This program has absolutely no warranty."
48     exit 0
49 }
50
51
52 is_quiet=
53 declare -a vservers=()
54
55 tmp=$(getopt -o +q --long help,version,debug,quiet -n "$0" -- "$@") || exit 1
56 eval set -- "$tmp"
57
58 while true; do
59     case "$1" in
60         (--help)        showHelp $0 ;;
61         (--version)     showVersion ;;
62         (--debug)       set -x;;
63         (--quiet|-q)    is_quiet=1 ;;
64         (--)            shift; break;;
65         (*)             echo $"vserver: internal error; arg=='$1'" >&2; exit 1;;
66     esac
67     shift
68 done
69
70 test "$#" -ge 1 || \
71     panic $"vsomething: no operation specified; try '--help' for more information"
72
73 cmd=$1
74 title=${VSOMETHING_TITLE:-$cmd}
75 shift
76
77 while test "$#" -ge 1; do
78     if getAllVserversByArg tmp "$1"; then
79         vservers=( "${vservers[@]}" "${tmp[@]}" )
80     else
81         case "$1" in
82             (--) shift; break;;
83             (*)  vservers=( "${vservers[@]}" "$1" )
84         esac
85     fi
86     shift
87 done
88
89
90 test "${#vservers[@]}" -ne 1 || is_quiet=1
91
92
93 cnt=0
94 res=255
95 for i in "${vservers[@]}"; do
96     cnt=$[ cnt + 1 ]
97
98     test -n "$is_quiet" || {
99         colorize bold echo -n "$title: operating on vserver "
100         colorize bold colorize emph echo "$i"
101         xtermTitle "$title: operating on vserver '$i'  [$cnt/${#vservers[@]}]"
102     }
103
104     if test -n "$VSOMETHING_PKGMGMT"; then
105         if pkgmgmt.isInternal "$i"; then
106             $_VSERVER "$i" exec "$cmd" "$@"
107         else
108             callInNamespace "$i" \
109                 "$_VNAMESPACE" --new -- "$VSOMETHING_WORKER" "$i" "$@"
110         fi
111     else
112         "$cmd" "$i" "$@"
113     fi
114         
115     res=$?
116
117     test $res -eq 0 -o -n "$is_quiet" || {
118         colorize error echo -n $"$title failed on vserver '$i' with errorcode $res"
119         echo
120     }
121         
122     test -n "$is_quiet" || echo
123 done
124
125 test "$cnt" -ge 0 || warning $"No vservers specified"
126 exit $res